Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation

<DefaultClassOptions()> _
<NavigationItem(False), CreatableItem(False)> _
Public Class BallanceHeader
    Inherits BaseObject

    Private _CustomersFrom As CustomersFrom

    Private _TrialBalanceHeaderBefore As TrialBalanceHeader 'Megelőző időszak fk. kivonata
    Private _TrialBalanceHeader As TrialBalanceHeader 'Aktuális időszak fk. kivonata

    Private _DateClose As Date
    Private _ShortName As String
    Private _ObjectCreated As Date
    Private _UserCreated As User

    Private _SpreadXML As String ' A mérleg - beszámolót tartalmazó excel
    Private _SpreadFileData As FileData

    Public Sub New(ByVal session As Session)
        MyBase.New(session)
        ' This constructor is used when an object is loaded from a persistent storage.
        ' Do not place any code here or place it only when the IsLoading property is false:
        ' if (!IsLoading){
        '   It is now OK to place your initialization code here.
        ' }
        ' or as an alternative, move your initialization code into the AfterConstruction method.
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        DateClose = GetSQLTime(Session)
    End Sub
    Protected Overrides Sub OnSaving()
        MyBase.OnSaving()
        If Session.IsNewObject(Me) Then
            ObjectCreated = GetSQLTime(Session)
            UserCreated = Session.GetObjectByKey(Of User)(Session.GetKeyValue(SecuritySystem.CurrentUser))
        End If
    End Sub

    <RuleRequiredField("BallanceHeader-CustomersFrom", DefaultContexts.Save)> _
    Property CustomersFrom As CustomersFrom
        Get
            Return _CustomersFrom
        End Get
        Set(value As CustomersFrom)
            SetPropertyValue("CustomersFrom", _CustomersFrom, value)
        End Set
    End Property
    Property TrialBalanceHeaderBefore As TrialBalanceHeader
        Get
            Return _TrialBalanceHeaderBefore
        End Get
        Set(value As TrialBalanceHeader)
            SetPropertyValue("TrialBalanceHeaderBefore", _TrialBalanceHeaderBefore, value)
        End Set
    End Property
    Property TrialBalanceHeader As TrialBalanceHeader
        Get
            Return _TrialBalanceHeader
        End Get
        Set(value As TrialBalanceHeader)
            SetPropertyValue("TrialBalanceHeader", _TrialBalanceHeader, value)
        End Set
    End Property
    <RuleRequiredField("BallanceHeader-DateClose", DefaultContexts.Save)> _
    Property DateClose As Date
        Get
            Return _DateClose
        End Get
        Set(value As Date)
            SetPropertyValue("DateClose", _DateClose, value)
        End Set
    End Property
    <Size(255)> _
    <RuleRequiredField("BallanceHeader-ShortName", DefaultContexts.Save)> _
    Property ShortName As String
        Get
            Return _ShortName
        End Get
        Set(value As String)
            SetPropertyValue("ShortName", _ShortName, value)
        End Set
    End Property
    <NonCloneable> _
    Property ObjectCreated As Date
        Get
            Return _ObjectCreated
        End Get
        Set(value As Date)
            SetPropertyValue("ObjectCreated", _ObjectCreated, value)
        End Set
    End Property
    <NonCloneable> _
    Property UserCreated As User
        Get
            Return _UserCreated
        End Get
        Set(value As User)
            SetPropertyValue("UserCreated", _UserCreated, value)
        End Set
    End Property

    <Size(-1)> _
    Property SpreadXML As String
        Get
            Return _SpreadXML
        End Get
        Set(value As String)
            SetPropertyValue("SpreadXML", _SpreadXML, value)
        End Set
    End Property
    Property SpreadFileData As FileData
        Get
            Return _SpreadFileData
        End Get
        Set(value As FileData)
            SetPropertyValue("SpreadFileData", _SpreadFileData, value)
        End Set
    End Property

    <VisibleInListView(False), VisibleInLookupListView(False)> _
    <Association("BallanceHeader-BallanceRows", GetType(BallanceRows))> _
    ReadOnly Property BallanceRows As XPCollection(Of BallanceRows)
        Get
            Return GetCollection(Of BallanceRows)("BallanceRows")
        End Get
    End Property

End Class
